/*
 * Use system call.
 * See gdb/sim/bfin/interp.c:bfin_syscall(),dv-bfin_cec.c:cec_exception()
 * (case VEC_SYS:)
 * See gdb/sim/testsuite/sim/bfin/cec-system-call.S (EXCPT 0)
 */

/*
 * System call number is changed from target to host by mapping table.
 * See gdb/sim/common/callback.c:cb_target_to_host_syscall()
 * See gdb/sim/bfin/interp.c:bfin_syscall() (call cb_target_to_host_syscall())
 * See gdb/sim/bfin/linux-targ-map.h:cb_linux_syscall_map[]
 * See gdb/include/gdb/callback.h (difinition of CB_SYS_XXXX)
 */
#define TARGET_LINUX_SYS_exit  1
#define TARGET_LINUX_SYS_read  3
#define TARGET_LINUX_SYS_write 4
#define TARGET_LINUX_SYS_open  5
#define TARGET_LINUX_SYS_close 6

	.org	0x1aec

	.section .text

	.globl	_start
	.type	_start, @function
_start:
_fname:	.string	"flag.txt"
	.byte	0x00
	.byte	0x00
	.byte	0x00
	.long	0

	.long	1f

1:
___open:
	R0.H	= _fname
	R0.L	= _fname
	R1	= 0
	P0	= TARGET_LINUX_SYS_open
	EXCPT	0

___read:
	R1.H	= _buffer
	R1.L	= _buffer
	R2	= 16
	P0	= TARGET_LINUX_SYS_read
	EXCPT	0

___write:
	R0	= 1
	R1.H	= _buffer
	R1.L	= _buffer
	R2	= 16
	P0	= TARGET_LINUX_SYS_write
	EXCPT	0

___exit:
	R0	= 0
	P0	= TARGET_LINUX_SYS_exit
	EXCPT	0
	RTS

_buffer:
